﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SyncfusionMvcApplication121;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript;
using Syncfusion.Linq;
using System.Collections;
namespace SyncfusionMvcApplication121.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        private static List<Customers> customerstable = new List<Customers>();
        public ActionResult GridFeatures()
        {
            if (customerstable.Count == 0)
                BindDataSource();
            return View();
        }
        private void BindDataSource()
        {
            //int orderId = 1000;
            int empId = 1000;
            
            {
                customerstable.Add(new Customers("VINET", empId + 1, 25, "Reims"));
                customerstable.Add(new Customers("TOMSP", empId + 2, 27, "Munster"));
                customerstable.Add(new Customers("ANATER", empId + 3, 28, "Berlin"));
                customerstable.Add(new Customers("ALFKI", empId + 4, 32, "Mexico"));
                customerstable.Add(new Customers("FRGYE", empId + 5, 33, "Colchester"));
               // orderId += 5;
                empId += 5;
            }
            
        }
        
        public ActionResult DataSource(DataManager dm)
        {
            IEnumerable DataSource = new NorthwindDataContext().EmployeeViews.ToList();
            DataResult result = new DataResult();
            DataOperations operation = new DataOperations();
            result.result = DataSource;
            List<string> str = new List<string>();
            if (dm.Aggregates != null)
            {
                for (var i = 0; i < dm.Aggregates.Count; i++)
                    str.Add(dm.Aggregates[i].Field);
                result.aggregate = operation.PerformSelect(DataSource, str);
            } 
 
            result.count = result.result.AsQueryable().Count();
            if (dm.Skip > 0)
                result.result = operation.PerformSkip(result.result, dm.Skip);
            if (dm.Take > 0)
                result.result = operation.PerformTake(result.result, dm.Take);
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public ActionResult DataSource2(DataManager ds)
        {
            IEnumerable DataSource = new NorthwindDataContext().OrdersViews.ToList();
            DataResult result = new DataResult();
            DataOperations operation = new DataOperations();
            result.result = DataSource;
            List<string> str = new List<string>();
            if (ds.Aggregates != null)
            {
                for (var i = 0; i < ds.Aggregates.Count; i++)
                    str.Add(ds.Aggregates[i].Field);
                result.aggregate = operation.PerformSelect(DataSource, str);
            }

            result.count = result.result.AsQueryable().Count();
            if (ds.Skip > 0)
                result.result = operation.PerformSkip(result.result, ds.Skip);
            if (ds.Take > 0)
                result.result = operation.PerformTake(result.result, ds.Take);
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public ActionResult DataSource3(DataManager dt)
        {
            IEnumerable Data = customerstable.ToList();
            int count = Data.AsQueryable().Count();
            Syncfusion.JavaScript.DataSources.DataOperations operation = new Syncfusion.JavaScript.DataSources.DataOperations();
            Data = operation.Execute(Data, dt);
            return Json(new { result = Data, count = count }, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
            public IEnumerable aggregate { get; set; }
            public IEnumerable groupDs { get; set; }
        }
        [Serializable]
        public class Customers{

            public Customers()
            {

            }
            public Customers(string CustomerId, long Phone, long Address, string Country)
            {
               
                this.CustomerID = CustomerId;
                this.Phone = Phone;
                this.Address = Address;
                this.Country = Country;
            }
            public string CustomerID { get; set; }
            public long Phone { get; set; }
            public long Address { get; set; }
            public string Country { get; set; }
        }
        
        }

    }
